473,769 Members | 4,173 Online
Bytes | Software Development & Data Engineering Community
+ Post

Home Posts Topics Members FAQ

nearest neighbor in 2D


I have a list of two tuples containing x and y coord

(x0, y0)
(x1, y1)
...
(xn, yn)

Given a new point x,y, I would like to find the point in the list
closest to x,y. I have to do this a lot, in an inner loop, and then I
add each new point x,y to the list. I know the range of x and y in
advance.

One solution that comes to mind is to partition to space into
quadrants and store the elements by quadrant. When a new element
comes in, identify it's quadrant and only search the appropriate
quadrant for nearest neighbor. This could be done recursively, a 2D
binary search of sorts....

Can anyone point me to some code or module that provides the
appropriate data structures and algorithms to handle this task
efficiently? The size of the list will likely be in the range of
10-1000 elements.

Thanks,
John Hunter
Jul 18 '05 #1
14 11507
>>>>> "John" == John Hunter <jd******@ace.b sd.uchicago.edu > writes:

John> Given a new point x,y, I would like to find the point in the list
John> closest to x,y. I have to do this a lot, in an inner loop, and
John> then I add each new point x,y to the list. I know the range of x
John> and y in advance.

John> One solution that comes to mind is to partition to space into
John> quadrants and store the elements by quadrant. When a new element
John> comes in, identify it's quadrant and only search the appropriate
John> quadrant for nearest neighbor. This could be done recursively, a
John> 2D binary search of sorts....

By recursion your solution would work in O(log n) time. The construction
would take O(n log n) time. Unluckily, it can return the wrong point, as
the nearest point within the nearest quadrant might not be the nearest
point.

The problem is a well-studied basic computational geometry problem, although
I don't really know any Python code that actually do it. Try to look at the
web for "Voronoi diagrams" and "radial triangulation" to understand how to
solve it properly in the above mentioned (perhaps randomized) time
complexity.

Regards,
Isaac.
Jul 18 '05 #2
John Hunter wrote:
I have a list of two tuples containing x and y coord

(x0, y0)
(x1, y1)
...
(xn, yn)

Given a new point x,y, I would like to find the point in the list
closest to x,y. I have to do this a lot, in an inner loop, and then I
add each new point x,y to the list. I know the range of x and y in
advance.

One solution that comes to mind is to partition to space into
quadrants and store the elements by quadrant. When a new element
comes in, identify it's quadrant and only search the appropriate
quadrant for nearest neighbor. This could be done recursively, a 2D
binary search of sorts....

Can anyone point me to some code or module that provides the
appropriate data structures and algorithms to handle this task
efficiently? The size of the list will likely be in the range of
10-1000 elements.

Thanks,
John Hunter

You could to a for loop, and inside that loop you will have a variable
lessest_distanc e. I dont know much geometric mathematics, but Im pretty
sure you can use pytagoras stuff to find the lenght from (Xn,Yn) to
(X,Y) using sinus cosinus and such.

And when the function is finished, you should return lessest_distanc e

Jul 18 '05 #3
John Hunter wrote:

One solution that comes to mind is to partition to space into
quadrants and store the elements by quadrant. When a new element
comes in, identify it's quadrant and only search the appropriate
quadrant for nearest neighbor. This could be done recursively, a 2D
binary search of sorts....


What happens when you put a particle in near/at the boundary of a quadrant
though? It's possible for the nearest neighbour to be in the nearest
neighbour quadrant...alth ough you could search over these as well.
However, the number of independent areas implied by use of the word
'quadrant' suggests that this would be the same as iterating over all
space.... :-)
--
Graham Lee
Wadham College
Oxford
Jul 18 '05 #4
At 2003-11-03T04:12:47Z, John Hunter <jd******@ace.b sd.uchicago.edu > writes:
One solution that comes to mind is to partition to space into quadrants
and store the elements by quadrant. When a new element comes in, identify
it's quadrant and only search the appropriate quadrant for nearest
neighbor.


Erm, no. Imagine that your new point is in one corner of a quadrant. The
other point in the quadrant is in the opposite corner. There is a point in
the adjacent quadrant that is infinitessimaly close to your new point.
That's where your algorithm breaks down.
--
Kirk Strauser
The Day Companies
Jul 18 '05 #5
>>>>> "Ron" == Ron Adam <ra****@tampaba y.rr.com> writes:

Ron> I really don't know how you can make this faster. There
Ron> might be a library that has a distance between two points
Ron> function that could speed it up.

If you only had to compare one point to all the other points, then the
brute force approach -- check every point -- will work great. This is
O(N) and I don't think you can beat it. The idea is that I will be
repeatedly checking and adding points to the list, so it is worthwhile
at the outset to set up a data structure which allows a more efficient
search.

The analogy is a binary search in 1D. If you plan to repeatedly
search a (possibly growing) list of numbers to see whether it contains
some number or find the nearest neighbor to a number, it is worthwhile
at the outset to put them in a data structure that allows a binary
search. Setting up the initial data structure costs you some time,
but subsequent searches are O(log2(N)). See google for 'binary
search' and the python module bisect.

So roughly, for a list with 1,000,000 elements, your brute force
approach requires a million comparisons per search. If the data is
setup for binary search, on average only 13-14 comparisons will be
required. Well worth the effort if you need to do a lot of searches,
as I do.

John Hunter

Jul 18 '05 #6
On Tue, 04 Nov 2003 08:25:36 -0800, David Eppstein
<ep******@ics.u ci.edu> wrote:
In article <bo************ *@news.t-online.com>,
Peter Otten <__*******@web. de> wrote:
This is of course all premature optimization as the most promising approach
is to try hard to reduce the number of candidate points, as David Eppstein
seems to have done. But then, he could use complex numbers, too.


Well, yes, but then my code wouldn't work very well in dimensions higher
than two...

I rearranged my first example to match the output of yours and used a
random number seed to get identical results.

Moving the square root to the return line of the find shortest
distance function increased the speed of my routine about 20%. Then
using the p*p form instead of p**2 added anouther 4%.

With printing turned there is only a very small difference. Of course
printing is the bottle neck. Turning off printing resulted in the
following. All are best of 3 runs.

1000 points:
Standard loop: 0:00:00.958192
Kdtree: 0:00:00.248096

Quite a difference. I'm not quite sure how kdtree's work. (yet) But
they can be worth while when working with large data sets.

The standard loop seems to be better for small lists of < 100 points.

100 points:
Standard loop: 0:00:00.009966
kdtree 0:00:00.015247

But for really large lists.

10000 points:
Standard loop: 0:01:39.246454
kdtree 0:00:03.424873

Hehe.... no comparison.

The number of calculations the standard loop does:

100 new points, 4950 distance calculations.
1000 new points, 499500 distance calculations.
10000 new points, 49995000 distance calculations.

And I don't know how to figure it for kdtree. But we can estimate it
by using the ratio of the speeds.

1000 points:
kdtree (3.42/99.25)*49995000 = 1722749.62 est. dist. calculations.

There's probably a better way to do that. Python is fun to do this
stuff with. Playing around like this with other languages is just too
much trouble.

_Ron





Jul 18 '05 #7
On Tue, Nov 04, 2003 at 01:02:36PM -0600, John Hunter wrote:
>> "Ron" == Ron Adam <ra****@tampaba y.rr.com> writes:


Ron> I really don't know how you can make this faster. There
Ron> might be a library that has a distance between two points
Ron> function that could speed it up.

If you only had to compare one point to all the other points, then the
brute force approach -- check every point -- will work great. This is
O(N) and I don't think you can beat it. The idea is that I will be
repeatedly checking and adding points to the list, so it is worthwhile
at the outset to set up a data structure which allows a more efficient
search.

The analogy is a binary search in 1D. If you plan to repeatedly
search a (possibly growing) list of numbers to see whether it contains
some number or find the nearest neighbor to a number, it is worthwhile
at the outset to put them in a data structure that allows a binary
search. Setting up the initial data structure costs you some time,
but subsequent searches are O(log2(N)). See google for 'binary
search' and the python module bisect.

So roughly, for a list with 1,000,000 elements, your brute force
approach requires a million comparisons per search. If the data is
setup for binary search, on average only 13-14 comparisons will be
required. Well worth the effort if you need to do a lot of searches,
as I do.

John Hunter


Breaking into the thread late, I've been busy enough to put down c.l.py
for a couple weeks.

If you only need to compare 10-1000 points, try this approach below. I
wrote it for the ICFP programming contest where I was sorting lots and
lots of points lots and lots of times. It sorts a list of points for
their manhattan distance from a particular point. I tweaked it until
it was just fast enough to do what I wanted. I won't pretend it is
optimal for all N, just that it was good enough for _my_ N. The speed
trick is that the point we are sorting around is stored in an object that
is created only once, and then we make the object's __call__ be the
comparison function.

Since it uses the list.sort() method we don't have to do anything more
clever than write our comparison function in C. I trust the Timbot
has written a better list.sort() than I ever will, so let's use it.

it is used thusly:

import icfp

l = [your big list of point tuples like (1, 10)]
p = (99, 22) # find nearest point in l to p

sort_ob = icfp.manhattan_ sort(p) # creates a callable Manhat object that remembers p

l.sort(sort_ob) # sorts around p
print "closest", l[0]
print "farthest", l[-1]

The below code is from my CVS tree, so it should probably work. It was
written in a rush for a contest (JDH, you may recognize parts that are
cut-n-pasted from "probstat") so YMMV.

-jack

NB, if there is a boost or pyrex guy listening you might want to
throw in an easilly derived class that makes this [ab]use of __call__ easy.
It was a big performance win for me for very little effort.
""" icfp_module.c """

#include "Python.h"
#include <stdio.h>
#include <stdlib.h>

/*
* stats module interface
*/

static PyObject *ErrorObject;

PyObject *manhat_new(PyO bject *self, PyObject *args);

static PyTypeObject Manhat_Type;

static PyObject *
heur1(PyObject *self, PyObject *args)
{
PyObject *tup1;
PyObject *tup2;
long x,y;

if (!PyArg_ParseTu ple(args, "O!O!", &PyTuple_Typ e, &tup1, &PyTuple_Typ e, &tup2)) {
return NULL;
}
x = PyInt_AsLong(Py Tuple_GET_ITEM( tup1,0)) - PyInt_AsLong(Py Tuple_GET_ITEM( tup2,0));
y = PyInt_AsLong(Py Tuple_GET_ITEM( tup1,1)) - PyInt_AsLong(Py Tuple_GET_ITEM( tup2,1));
return PyInt_FromLong( labs(x * x) + labs(y * y));
}

static PyMethodDef stats_methods[] = {
{"manhattan" , heur1, METH_VARARGS},
{"manhattan_sor t", manhat_new, METH_VARARGS},
{NULL, NULL} /* sentinel */
};

DL_EXPORT(void)
initicfp(void)
{
PyObject *m, *d;

PyPQueue_Type.o b_type = &PyType_Type ;
Manhat_Type.ob_ type = &PyType_Type ;

/* Create the module and add the functions */
m = Py_InitModule(" icfp", stats_methods);

/* Add some symbolic constants to the module */
d = PyModule_GetDic t(m);
ErrorObject = PyErr_NewExcept ion("icfp.error ", NULL, NULL);
}

""" manhattan.c """
#include "Python.h"
#include <stdio.h>

#define ManhatObject_Ch eck(v) ((v)->ob_type == &Manhat_Type )

staticforward PyTypeObject Manhat_Type;

typedef struct {
PyObject_HEAD
long x;
long y;
} ManhatObject;
static void
Manhat_dealloc( ManhatObject *self) {
PyObject_Del(se lf);
}

static PyObject *
Manhat_call(Man hatObject *self, PyObject *args)
{
PyObject *tup1;
PyObject *tup2;
long a;
long b;
long x;
long y;

if (!PyArg_ParseTu ple(args, "O!O!", &PyTuple_Typ e, &tup1, &PyTuple_Typ e, &tup2)) {
return NULL;
}
x = PyInt_AsLong(Py Tuple_GET_ITEM( tup1,0)) - self->x;
y = PyInt_AsLong(Py Tuple_GET_ITEM( tup1,1)) - self->y;
a = labs(x * x) + labs(y * y);

x = PyInt_AsLong(Py Tuple_GET_ITEM( tup2,0)) - self->x;
y = PyInt_AsLong(Py Tuple_GET_ITEM( tup2,1)) - self->y;
b = labs(x * x) + labs(y * y);

if (a == b)
return PyInt_FromLong( 0);
else if (a < b)
return PyInt_FromLong(-1);
else
return PyInt_FromLong( 1);
}

static PyMethodDef Manhat_methods[] = {
{NULL, NULL} /* sentinel */
};

statichere PyTypeObject Manhat_Type = {
/* The ob_type field must be initialized in the module init function
* to be portable to Windows without using C++. */
PyObject_HEAD_I NIT(&PyType_Typ e)
0, /*ob_size*/
"Manhat", /*tp_name*/
sizeof(ManhatOb ject), /*tp_basicsize*/
0, /*tp_itemsize*/
/* methods */
(destructor)Man hat_dealloc, /*tp_dealloc*/
0, /*tp_print*/
0, /*tp_getattr*/
0, //(setattrfunc)Pe rmute_setattr, /*tp_setattr*/
0, /*tp_compare*/
0, /*tp_repr*/
0, /*tp_as_number*/
0, /*tp_as_sequence */
0, /*tp_as_mapping*/
0, /*tp_hash*/
(ternaryfunc)Ma nhat_call, /*tp_call*/
0, /*tp_str*/
PyObject_Generi cGetAttr, /*tp_getattro*/
0, /*tp_setattro*/
0, /*tp_as_buffer*/
Py_TPFLAGS_DEFA ULT, /*tp_flags*/
0, /*tp_doc*/
0, /*tp_traverse*/
0, /*tp_clear*/
0, /*tp_richcompare */
0, /*tp_weaklistoff set*/
0, /*tp_iter*/
0, /*tp_iternext*/
Manhat_methods, /*tp_methods*/
0, /*tp_members*/
0, /*tp_getset*/
0, /*tp_base*/
0, /*tp_dict*/
0, /*tp_descr_get*/
0, /*tp_descr_set*/
0, /*tp_dictoffset*/
0, /*tp_init*/
0, /*tp_alloc*/
0, /*tp_new*/
0, /*tp_free*/
0, /*tp_is_gc*/
};

// not static so ifcp_module.c can see it
PyObject *
manhat_new(PyOb ject *self, PyObject *args)
{
ManhatObject *mh;
PyObject *tup1;

if (!PyArg_ParseTu ple(args, "O!", &PyTuple_Typ e, &tup1)) {
return NULL;
}
// call object create function and return
mh = PyObject_New(Ma nhatObject, &Manhat_Type );
if (mh == NULL)
return NULL;

mh->x = PyInt_AsLong(Py Tuple_GET_ITEM( tup1,0));
mh->y = PyInt_AsLong(Py Tuple_GET_ITEM( tup1,1));
return (PyObject *)mh;
}

""" setup.py """

from distutils.core import setup, Extension

files = [
'manhattan.c',
'icfp_module.c' ,
]

libraries = []
#libraries = ["efence"] # uncomment to use ElectricFence
includes = []
if (__name__ == '__main__'):
setup(name = "icfp", version = "0.2",
ext_modules = [Extension("icfp ", files,
libraries = libraries,
include_dirs = includes,
)
]
)
Jul 18 '05 #8
On Tue, 04 Nov 2003 17:13:58 +0100,
Peter Otten <__*******@web. de> wrote:
Alex Martelli wrote:
Andrew Dalke wrote:
Ron Adam
for point in p:
distance = math.sqrt((new_ point[0]-point[0])**2 \
+(new_point[1]-point[1])**2)

I really don't know how you can make this faster. There might be a


Hmmm, that's what math.hypot is for, isn't it...?

[alex@lancelot Lib]$ timeit.py -c -s'import math; p=1.6,2.5; np=2.4,1.3'
'math.sqrt((np[0]-p[0])**2 + (np[1]-p[1])**2)'
100000 loops, best of 3: 3 usec per loop

[alex@lancelot Lib]$ timeit.py -c -s'import math; p=1.6,2.5; np=2.4,1.3'
'math.hypot(np[0]-p[0], np[1]-p[1])'
100000 loops, best of 3: 1.9 usec per loop

library that has a distance between two points function that could
speed it up.

An easy way is to move the math.sqrt call outside the loop, since
sqrt(d1) < sqrt(d2) iff d1 < d2 (when d1,d2>=0)


Yes, omitting the math.sqrt gives the same speed as calling math.hypot,
and it's the classic solution to speed up minimum-distance problems.

I vaguely suspect you could shave some further fraction of a microsecond
by saving those differences as dx and dy and then computing dx*dx+dy*dy --
since another classic tip is that a**2 is slower than a*2. Let's see...:

[alex@lancelot Lib]$ timeit.py -c -s'import math; p=1.6,2.5; np=2.4,1.3'
'dx=np[0]-p[0]; dy=np[1]-p[1]; disq=dx*dx+dy*d y'
1000000 loops, best of 3: 1.39 usec per loop

...yep, another small enhancement. Ain't measuring _FUN_?-)


Finally found an application for complex numbers:

...> timeit.py -s"p= 1.6+2.5j; np=2.4+1.3j" "d=abs(p-np)"
1000000 loops, best of 3: 0.436 usec per loop

...> timeit.py -s"p= 1.6,2.5; np=2.4,1.3" "dx=np[0]-p[0];
dy=np[1]-p[1];d=dx*dx+dy*dy"
1000000 loops, best of 3: 1.15 usec per loop

This is of course all premature optimization as the most promising approach
is to try hard to reduce the number of candidate points, as David Eppstein
seems to have done. But then, he could use complex numbers, too.

Peter

I am new to timeit.py, but this is odd.

jim@grendel:~$ /usr/lib/python2.3/timeit.py -c ' p=1.6+2.5j;np=2 .4+1.3j; d=abs(p-np)'
100000 loops, best of 3: 3.1 usec per loop

vs

jim@grendel:~$ /usr/lib/python2.3/timeit.py -c -s'import math; p=1.6+2.5j;np=2 .4+1.3j; d=abs(p-np)'
10000000 loops, best of 3: 0.141 usec per loop

Is it because the builtin math functions are much slower?
--
Jim Richardson http://www.eskimo.com/~warlock
Televangelists: The Pro Wrestlers of Religion
Jul 18 '05 #9
On Mon, 03 Nov 2003 22:15:34 -0600, John Hunter
<jd******@ace.b sd.uchicago.edu > wrote:
I had two use cases just yesterday. The one that prompted the
question arose in making a contour plot. I'm defining a contour as an
ordered sequence of values over a 2D MxN matrix where the values
differ from some target value by at most some tolerance. I maintain a
list of i,j indices into the matrix for a given contour value, and
follow the contour from a given i,j location by examining its
neighbors. In order to close the loop (eg, when the contour finder
has passed once around a level curve of a mountain, I want to test
whether a given point i,j is close to a previously discovered point
k,l. Since I have a list of these 2 tuple coordinates, I want to find
the nearest neighbor in the list and terminate the contour when the
nearest neighbor falls within some minimum distance

3 4 5
2 6
13 1 7
12 8
11 10 9

In the example above, I am traversing a contour identifying points in
the order 1,2,3...; as above each point represents an i,j tuple which
is an index into the matrix I am contouring. I would like to
terminate the search at 13 rather than spiral around the existing
contour 1-12. Each time I add a new point to the contour, I would like
to query the existing list (excluding the most recently added points
which are close by construction) of locations and find the minimum
distance. If I'm not too close to the preexisting contour, I add the
new point and proceed.

As I write this I realize there is an important efficiency. Since
from an existing point I add the closest neighbor, the biggest step I
can make is 1,1. If on the last nearest neighbor query I find a
minimum distance of d, it will take me d minimum steps to approach the
existing contour. So I don't need to check the distance again for at
least d steps. So the algorithm can proceed 1) obtain the distance d
from the existing contour to the most recently obtained point 2) make
d steps adding points that meet the value criteria 3) repeat.

The second use case arose with gdmodule, which can only allocate 256
colors, which I cache as a dict from rgb tuples (eg, 0.0, 0.05, 1.0)
to color. When the total number of color allocations is made, and a
new rgb request comes into the color manager, I pick the already
allocated point in rgb space closest to the requested point.

I'll try David Eppstein's approach tomorrow and see how this fares.

Thanks to all for suggestions,
John Hunter

Ah, a contour map. Maybe something like this?
"""
Where pointA and pointB are constitutive points in a list, and pointC
is a new point from a list of new points.

For each pointC in a list of new points.
For each consecutive 2 points in a list of sequential points.
If lineAC < lineAB and lineBC < lineAB
Insert pointC between pointA and pointB

If pointC was not placed in list of sequential points.
Where pointA and pointB are the beginning and
end points of the list.

IF lineAC < lineBC
Add pointC to beginning of list.
Else add pointC to end of list.

When done copy point from beginning of list to end of list
to complete polygon.
"""
Just knowing the closest point isn't quite enough because it doesn't
tell you weather to put it in front or behind the point in the list.
Storing the distance to the next point along with each point might
make it work faster. This method has an advantage in that it doesn't
have to go through the whole list. You could start from the closest
end of the list and maybe make it quicker.

One catch is you need to know in advance that the set of points are
not divided by a hill or valley.

I'm not sure what this would do with a list of random points. Maybe a
long squiggly line where the beginning to end segment cuts across
them. I don't think you will have that problem.

_Ron
Jul 18 '05 #10

This thread has been closed and replies have been disabled. Please start a new discussion.

Similar topics

4
6796
by: tertius | last post by:
Hi, I'm trying to round my float total to the nearest .05 cents. 12.01 should produce 12.00 0.14 should produce 0.10 2.28 " 2.25 703.81 " 703.80 "%.02f"%100.0099 produces 100.01 (which I know is right)
2
2629
by: nkunapa | last post by:
Hi: Is there a way in XPATH to find the nearest node of the node in context with a certain attribute value. Here is my problem. I have the following XML and I am trying to add all the nodes with attribute value LNum=1 as child nodes of the nearest node above it with attribute LNum=0....and add all the nodes with attribute value LNum=2 as child nodes of the nearest node above it with attribute LNum=1 and so on. The LNum value can go...
1
303
by: Moukarram Kabbash | last post by:
Hello everybody, how can I get the names of all neighbor computers in my local network ? Thanks in advance
8
2848
by: Gompie | last post by:
Why does the function DMin("Abs(!- #" & & "#)";"SomeTable") not work properly with datefields. It always finds the closest difference with a later date only, if an earlier date in the table is closer or even equal, it still comes up with the later date. It works fine with numeric fields. (of course without the number signs) Anybody knows why?
4
3073
by: naren2345 | last post by:
Would this expression round an integer n to the nearest power of 4 ? ((n-1)|3) + 1
3
1482
by: Valvalis | last post by:
Hello, I am trying to set a class attribute of a text.item element to the value of its nearest ancestor. I want to do this in the case that the class of the text.item is currently a blank string. <text class="read-only"> ... <text.item class=""/> //this element should inherit the class attribute "read-only" from text <foo class="read-write"> <text.item class="" /> //this element should inherit the class attribute...
3
7130
by: runner7 | last post by:
Can someone tell me how to make a div stretch vertically so it is always the same height as its neighbor div, while the neighbor div expands to fit its content (like a navigation bar on the left always the same height as the content div)?
3
2705
by: Waqas Danish | last post by:
Hi, I am planning to use Nearest Neighbor algorithm for predicting the user behavior. Basically, I have a large number of reviews along with their star ratings(1-5). For a new user that registers with my system, I want to show him the best matched results when that new user searches for an item. For example, UserA and UserB have rated three items in my system and UserC has only rated one. How can I be able to pair the users matching their...
0
9423
by: Hystou | last post by:
Most computers default to English, but sometimes we require a different language, especially when relocating. Forgot to request a specific language before your computer shipped? No problem! You can effortlessly switch the default language on Windows 10 without reinstalling. I'll walk you through it. First, let's disable language synchronization. With a Microsoft account, language settings sync across devices. To prevent any complications,...
0
10211
Oralloy
by: Oralloy | last post by:
Hello folks, I am unable to find appropriate documentation on the type promotion of bit-fields when using the generalised comparison operator "<=>". The problem is that using the GNU compilers, it seems that the internal comparison operator "<=>" tries to promote arguments from unsigned to signed. This is as boiled down as I can make it. Here is my compilation command: g++-12 -std=c++20 -Wnarrowing bit_field.cpp Here is the code in...
0
10045
jinu1996
by: jinu1996 | last post by:
In today's digital age, having a compelling online presence is paramount for businesses aiming to thrive in a competitive landscape. At the heart of this digital strategy lies an intricately woven tapestry of website design and digital marketing. It's not merely about having a website; it's about crafting an immersive digital experience that captivates audiences and drives business growth. The Art of Business Website Design Your website is...
1
9994
by: Hystou | last post by:
Overview: Windows 11 and 10 have less user interface control over operating system update behaviour than previous versions of Windows. In Windows 11 and 10, there is no way to turn off the Windows Update option using the Control Panel or Settings app; it automatically checks for updates and installs any it finds, whether you like it or not. For most users, this new feature is actually very convenient. If you want to control the update process,...
0
9863
tracyyun
by: tracyyun | last post by:
Dear forum friends, With the development of smart home technology, a variety of wireless communication protocols have appeared on the market, such as Zigbee, Z-Wave, Wi-Fi, Bluetooth, etc. Each protocol has its own unique characteristics and advantages, but as a user who is planning to build a smart home system, I am a bit confused by the choice of these technologies. I'm particularly interested in Zigbee because I've heard it does some...
0
8872
agi2029
by: agi2029 | last post by:
Let's talk about the concept of autonomous AI software engineers and no-code agents. These AIs are designed to manage the entire lifecycle of a software development project—planning, coding, testing, and deployment—without human intervention. Imagine an AI that can take a project description, break it down, write the code, debug it, and then launch it, all on its own.... Now, this would greatly impact the work of software developers. The idea...
1
7409
isladogs
by: isladogs | last post by:
The next Access Europe User Group meeting will be on Wednesday 1 May 2024 starting at 18:00 UK time (6PM UTC+1) and finishing by 19:30 (7.30PM). In this session, we are pleased to welcome a new presenter, Adolph Dupré who will be discussing some powerful techniques for using class modules. He will explain when you may want to use classes instead of User Defined Types (UDT). For example, to manage the data in unbound forms. Adolph will...
0
5299
by: TSSRALBI | last post by:
Hello I'm a network technician in training and I need your help. I am currently learning how to create and manage the different types of VPNs and I have a question about LAN-to-LAN VPNs. The last exercise I practiced was to create a LAN-to-LAN VPN between two Pfsense firewalls, by using IPSEC protocols. I succeeded, with both firewalls in the same network. But I'm wondering if it's possible to do the same thing, with 2 Pfsense firewalls...
3
2815
bsmnconsultancy
by: bsmnconsultancy | last post by:
In today's digital era, a well-designed website is crucial for businesses looking to succeed. Whether you're a small business owner or a large corporation in Toronto, having a strong online presence can significantly impact your brand's success. BSMN Consultancy, a leader in Website Development in Toronto offers valuable insights into creating effective websites that not only look great but also perform exceptionally well. In this comprehensive...

By using Bytes.com and it's services, you agree to our Privacy Policy and Terms of Use.

To disable or enable advertisements and analytics tracking please visit the manage ads & tracking page.